/*eslint-disable*/
<template>
  <div>
    <v-alert
      v-if="launched"
      :value="!succesAlert"
      type="error"
      transition="scale-transition"
      dismissible
      close-icon="mdi-delete"
      >Cannot connect to server</v-alert
    >

    <v-alert
      v-if="launched"
      :value="succesAlert"
      type="success"
      transition="scale-transition"
      dismissible
      close-icon="mdi-delete"
      >Connected to the server!</v-alert
    >
    <h1>Websockets streaming</h1>
    <h1 class="my-10">Check the developer console for the messages</h1>

    <v-layout row>
      <v-spacer></v-spacer>

      <v-file-input
        show-size
        counter
        dense
        label="File input"
        v-model="file"
      ></v-file-input>

      <v-btn color="primary" text @click="submitFiles">SUBMIT</v-btn>
      <v-checkbox v-model="KNNcheckbox" :label="`use KNN`"></v-checkbox>
      
      <v-spacer></v-spacer>

    </v-layout>
    <v-layout row>
      <v-spacer></v-spacer>
      <h3>Point chunk size:</h3>
      <v-text-field
        v-model="pointChunkSize"
        hide-details
        single-line
        type="number"
        max="10000"
        min="1"
        value="100"
        onblur
      />
          <v-spacer></v-spacer>

    </v-layout>
    <v-layout row>
      <v-spacer></v-spacer>
      <h3>Amount of separate projectors:</h3>
      <v-text-field
        v-model="projectorAmount"
        hide-details
        single-line
        type="number"
        max="10"
        min="1"
        value="1"
        onblur
      />
      <h3>KNN word:</h3>
      <v-text-field v-model="KNNword" clearable></v-text-field>
      <v-btn color="primary" text @click="submitWord">SUBMIT</v-btn>

      <v-spacer></v-spacer>
    </v-layout>
  </div>
</template>

<script>
const Papa = require("papaparse");
const { Kafka,logLevel} = require('kafkajs')
const ip = require('ip')


export default {
  name: "webSocketClient",
  data() {
    return {
      projectorAmount: 1,
      pointChunkSize:100,
      succesAlert: false,
      launched: false,
      file: null,
      connection: null,
      KNNcheckbox: true,
      KNNword: "King",
      userID:null,
      kafkaTopic: null,
      kafka: null,
      kafkaProducer: null,
      brokerIP: 'tcp://0.0.0.0:9092'
    };
  },

  created: function () {
    let self = this;
    console.log(ip.address())
    this.connection = new WebSocket("ws://127.0.0.1:1234");



    this.connection.onopen = function (event) {
      self.succesAlert = true;
      self.launched = true;
      self.connection.send(JSON.stringify({"type": "GetUserID"}));

      console.log(event);
    };

    this.connection.onerror = function (event) {
      self.launched = true;
      console.log(event);
    };

    this.connection.onmessage = function (event) {
      const jsonMessage = JSON.parse(event.data);
      self.parseMessage(jsonMessage)      
    };

    this.connection.onclose = function (event) {
      console.log("Closed");
      console.log(event);
    };
  },


  methods: {
    parseMessage(jsonMessage){
      switch (jsonMessage["type"]) {
        case "userID":
          this.userID = parseInt(jsonMessage["userID"])
          this.kafkaTopic = jsonMessage["kafkaTopic"]
          console.log("Assigned clientID: " + this.userID + " kafkaTopic: " + this.kafkaTopic)


          this.kafka = new Kafka({
          logLevel: logLevel.DEBUG,
          clientId: 'webClient'+this.userID,
          brokers: [this.brokerIP]
          })
          break;
        case "error":
          var error = jsonMessage["message"];
          console.log(error);
          break;
        case "points":
          var points = jsonMessage["points"];
          if (!points) {
            console.log("empty message")
            return
            }
          points.forEach(point => {this.$emit("newPoint", point);});          
          break;
        case "neighbour":
          var neighbour = jsonMessage["neighbour"];
          var distance = jsonMessage["distance"];
          console.log("Word: " + neighbour + " Distance: " + distance);
          break;
        default:
          console.log("No implementation for " + jsonMessage["type"]);
          }

    },

    //Estimate to quickly calculate size
    getLineCountEstimate(file, callback) {
      var totalSize = 0;
      var lineCount = 0;

      //Use papaparse with preview
      Papa.parse(file, {
        worker: true,
        delimiter: " ",
        preview: 1000,
        step: function (row) {
          lineCount += 1;
          row.data.forEach((string) => {
            totalSize += Buffer.byteLength(string, "utf8");
          });
        },
        complete: function () {
          var estimate = Math.round((lineCount / totalSize) * file.size * 0.92);
          console.log("Estimated size: " + estimate);
          callback(estimate);
        },
      });
    },

    async parseData(lineCount) {
      //Send necessary information
      /*
      self.connection.send(
        JSON.stringify({
          type: "setProjectorAmount",
          amount: this.projectorAmount,
        })
      );

      self.connection.send(
        JSON.stringify({
          type: "setLineCount",
          amount: lineCount,
        })
      );

      if (this.KNNcheckbox) {
        self.connection.send(
          JSON.stringify({
            type: "getKNN",
          })
        );
      }
      */   


      console.log("Producer")

      this.uploadFileStream(lineCount)
      return;
    },

    uploadFileStream(lineCount) {
      console.log("Filesize: ", this.file.size);
      console.log(lineCount + " lines");
      let self = this

      Papa.parse(this.file, {
        worker: true,
        delimiter: " ",
        fastMode: false,
        step: async function (row) {
          self.connection.send(JSON.stringify({type:"UploadPoint","topic":self.kafkaTopic,point:row.data}))
        },
        complete: function () {        
        console.log("All done!");
        },
      });
    },
    
    submitWord() {
      if (this.KNNword == "") {
        console.log("No word entered");
        return;
      }

      if (this.KNNword.includes(" ")) {
        console.log("Dont use spaces inbetween words, for example use King-man+woman");
        return;
      }

      this.connection.send(
        JSON.stringify({
          type: "getKNNNeighbours",
          k: "10",
          word: this.KNNword,
        })
      );
      console.log("Send request for: " + this.KNNword);
    },
    
    submitFiles() {
      //Start up normal connection
      if (!this.file) {
        console.log("there is no file.");
        return;
      }
      //First get the lineCount, (we need that beforehand to know where to distribute the points)
      this.getLineCountEstimate(this.file, (lineCount) => {
        this.parseData(lineCount);
      });
    },
  },
};
</script>